#ifndef _EVENTCALLERCP_H_
#define _EVENTCALLERCP_H_

template <class T>
class CProxyIEventCallerEvents : public IConnectionPointImpl<T, &IID_IEventCallerEvents, CComDynamicUnkArray>
{
	//Warning this class may be recreated by the wizard.
public:
	HRESULT Fire_OnEvent(BSTR signal)
	{
		HRESULT ret;
		T* pT = static_cast<T*>(this);
		int nConnectionIndex;
		int nConnections = m_vec.GetSize();
		
		for (nConnectionIndex = 0; nConnectionIndex < nConnections; nConnectionIndex++)
		{
			pT->Lock();
			CComPtr<IUnknown> sp = m_vec.GetAt(nConnectionIndex);
			pT->Unlock();
			IEventCallerEvents* pIEventCallerEvents = reinterpret_cast<IEventCallerEvents*>(sp.p);
			if (pIEventCallerEvents != NULL)
				ret = pIEventCallerEvents->OnEvent(signal);
		}	return ret;
	
	}
};
#endif