VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Event Schedule Editor driver"
   ClientHeight    =   2760
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5475
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2760
   ScaleWidth      =   5475
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkAddNew 
      Alignment       =   1  'Right Justify
      Caption         =   "Not yet Added"
      Enabled         =   0   'False
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   2400
      Width           =   1335
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete"
      Height          =   375
      Left            =   3840
      TabIndex        =   10
      Top             =   2280
      Width           =   1455
   End
   Begin VB.CommandButton cmdAddNew 
      Caption         =   "AddNew"
      Height          =   375
      Left            =   3840
      TabIndex        =   9
      Top             =   1800
      Width           =   1455
   End
   Begin VB.CheckBox chkDeleted 
      Alignment       =   1  'Right Justify
      Caption         =   "To be Deleted"
      Enabled         =   0   'False
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   2040
      Width           =   1335
   End
   Begin VB.CheckBox chkDirty 
      Alignment       =   1  'Right Justify
      Caption         =   "Is Dirty"
      Enabled         =   0   'False
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   1680
      Width           =   1335
   End
   Begin VB.TextBox txtRtime 
      Height          =   315
      Left            =   1680
      TabIndex        =   5
      Top             =   1320
      Width           =   1935
   End
   Begin VB.ComboBox cbSignal 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   840
      Width           =   3495
   End
   Begin VB.CommandButton cmdRefresh 
      Caption         =   "Refresh"
      Height          =   375
      Left            =   3840
      TabIndex        =   3
      Top             =   1320
      Width           =   1455
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "Apply"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3840
      TabIndex        =   2
      Top             =   840
      Width           =   1455
   End
   Begin VB.TextBox txtConnection 
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Text            =   "DSN=EventCaller;PWD=;UID=sa;Database=EventCaller"
      Top             =   360
      Width           =   5175
   End
   Begin VB.Label Label2 
      Caption         =   "Repeate time"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1320
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Connection string"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4575
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_rs As ADODB.Recordset
Private m_signal() As String, m_rtime() As Long, m_dirty() As Byte
Private m_bLockDirty As Boolean

Private Sub cbSignal_Click()
    Dim i As Integer
    i = cbSignal.ItemData(cbSignal.ListIndex)
    m_bLockDirty = True
    txtRTime = CStr(m_rtime(i))
    m_bLockDirty = False
    
    If (m_dirty(i) And 1) <> 0 Then
        chkDirty.Value = Checked
    Else
        chkDirty.Value = Unchecked
    End If
    If (m_dirty(i) And 2) <> 0 Then
        chkDeleted.Value = Checked
    Else
        chkDeleted.Value = Unchecked
    End If
    If (m_dirty(i) And 4) <> 0 Then
        chkAddNew.Value = Checked
    Else
        chkAddNew.Value = Unchecked
    End If
End Sub

Private Sub cmdAddNew_Click()
    Dim frm As frmNewSignal
    Set frm = New frmNewSignal
    frm.SetParent Me
    frm.Show vbModal, Me
    
    If frm.IsCancelled Then Exit Sub
    
    Dim n As Integer
    n = cbSignal.ListCount
    ReDim Preserve m_signal(n + 1) As String
    ReDim Preserve m_rtime(n + 1) As Long
    ReDim Preserve m_dirty(n + 1) As Byte
    m_signal(n) = frm.txtSignal.Text
    m_rtime(n) = CLng(frm.txtRTime.Text)
    m_dirty(n) = 5
    With cbSignal
        .AddItem m_signal(n)
        .ItemData(.NewIndex) = n
        .ListIndex = .NewIndex
    End With
    chkAddNew.Value = Checked
    cmdApply.Enabled = True
End Sub

Public Function CheckSignalName(sSignal As String) As Boolean
    CheckSignalName = False
    If Len(sSignal) > 50 Then Exit Function
    
    Dim i As Integer
    For i = 0 To cbSignal.ListCount - 1
        If cbSignal.List(i) = sSignal Then Exit Function
    Next i
    CheckSignalName = True
End Function

Private Sub cmdApply_Click()
    Dim sch As ScheduleEditor.ScheduleEditor
    Set sch = New ScheduleEditor.ScheduleEditor
    
    On Error GoTo errSched
    Dim i As Long
    For i = LBound(m_dirty) To UBound(m_dirty)
        If (m_dirty(i) And 2) <> 0 Then
            sch.EditSchedule txtConnection, m_signal(i), -1
        ElseIf (m_dirty(i) And 1) <> 0 Then
            sch.EditSchedule txtConnection, m_signal(i), m_rtime(i)
        End If
    Next i
    
    On Error GoTo lerr
    Set sch = Nothing
    RefreshData
    On Error GoTo 0
    Exit Sub
    
errSched:
    MsgBox "Error! Can't connect to the database", vbCritical
    Exit Sub
lerr:
    Set sch = Nothing
    MsgBox Err.Description
End Sub

Private Sub cmdDelete_Click()
    Dim i As Integer
    i = cbSignal.ItemData(cbSignal.ListIndex)
    m_dirty(i) = m_dirty(i) Or 2
    chkDeleted.Value = Checked
    cmdApply.Enabled = True
End Sub

Private Sub cmdRefresh_Click()
    RefreshData
End Sub

Private Sub Form_Load()
    m_bLockDirty = False
    RefreshData
End Sub

Private Sub RefreshData()
    Erase m_signal
    Erase m_rtime
    Erase m_dirty
    cbSignal.Clear
    
    On Error GoTo lerr
    Dim cn As New ADODB.Connection
    cn.ConnectionString = txtConnection
'    cn.CommandTimeout = 15
'    cn.IsolationLevel = adXactBrowse
    cn.Open
    
    Dim rs As New ADODB.Recordset
    rs.CursorLocation = adUseClient
    rs.LockType = adLockBatchOptimistic
    rs.Open "SELECT * FROM schedule", cn, adOpenStatic
    
    rs.MoveLast
    If rs.RecordCount > 0 Then
        ReDim m_signal(rs.RecordCount) As String
        ReDim m_rtime(rs.RecordCount) As Long
        ReDim m_dirty(rs.RecordCount) As Byte
        Dim i As Integer
        i = 0
        rs.MoveFirst
        Do While Not rs.EOF
            With cbSignal
                .AddItem rs.Fields!signal
                .ItemData(.NewIndex) = i
            End With
            m_signal(i) = rs.Fields!signal
            m_rtime(i) = rs.Fields!rtime
            m_dirty(i) = 0
            i = i + 1
            rs.MoveNext
        Loop
    End If
    rs.Close
    
    If i > 0 Then cbSignal.ListIndex = 0
    Exit Sub
    
lerr:
    MsgBox Err.Description
End Sub

Private Sub txtRTime_Change()
    Dim i As Integer
    If Not m_bLockDirty Then
        i = cbSignal.ItemData(cbSignal.ListIndex)
        m_dirty(i) = m_dirty(i) Or 1
        chkDirty.Value = Checked
        cmdApply.Enabled = True
    End If
End Sub

Private Sub txtRTime_LostFocus()
    Dim i As Integer, val As Long
    i = cbSignal.ItemData(cbSignal.ListIndex)
    If (m_dirty(i) And 1) = 0 Then Exit Sub
    
    On Error GoTo lerr
    val = CLng(txtRTime.Text)
    If val > 0 Then
        m_rtime(i) = val
        Exit Sub
    End If
lerr:
    MsgBox "InvalidValue"
    txtRTime.Text = CStr(m_rtime(i))
    txtRTime.SetFocus
End Sub
